OptionsWindow = class( Turbine.UI.Lotro.Window );

function OptionsWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	self:SetVisible( false );
	self:SetText( "Vital Bars" );
	self:SetSize( 400, 580 );

	self.HideCheckBox = Faflaf.FormElements.CheckBox();
	self.HideCheckBox:SetParent( self );
	self.HideCheckBox:SetChecked( settings.ShowDefault );
	self.HideCheckBox:SetText( "Show default character vitals?" );
	self.HideCheckBox:SetSize( self:GetWidth()-50, 40 );
	self.HideCheckBox:SetPosition( 20, 30 );
	
	-- setup width sliders
	self.MoraleSlider = Faflaf.FormElements.Slider();
	self.MoraleSlider:SetParent( self );
	self.MoraleSlider:SetText( "Morale Width" );
	self.MoraleSlider:SetSize( self:GetWidth()-40, 40 );
	self.MoraleSlider:SetPosition( 20, self.HideCheckBox:GetTop()+45 );
	self.MoraleSlider:SetStep( 1 );
	self.MoraleSlider:SetMin( 100 );
	self.MoraleSlider:SetMax( Turbine.UI.Display.GetWidth() );
	self.MoraleSlider:SetValue( vitalsWindow.moraleBar:GetWidth() );
	
	self.PowerSlider = Faflaf.FormElements.Slider();
	self.PowerSlider:SetParent( self );
	self.PowerSlider:SetText( "Power Width" );
	self.PowerSlider:SetSize( self:GetWidth()-40, 40 );
	self.PowerSlider:SetPosition( 20, self.MoraleSlider:GetTop()+45 );
	self.PowerSlider:SetStep( 1 );
	self.PowerSlider:SetMin( 100 );
	self.PowerSlider:SetMax(  Turbine.UI.Display.GetWidth() );
	self.PowerSlider:SetValue( vitalsWindow.powerBar:GetWidth() );

	-- setup checkboxen
	self.StackedCheckBox = Faflaf.FormElements.CheckBox();
	self.StackedCheckBox:SetParent( self );
	self.StackedCheckBox:SetChecked( vitalsWindow:IsStacked() );
	self.StackedCheckBox:SetText( "Stack Morale and Power bars?" );
	self.StackedCheckBox:SetSize( self:GetWidth()-50, 40 );
	self.StackedCheckBox:SetPosition( 20, self.PowerSlider:GetTop()+45 );

	self.MoraleTextCheckBox = Faflaf.FormElements.CheckBox();
	self.MoraleTextCheckBox:SetParent( self );
	self.MoraleTextCheckBox:SetChecked( vitalsWindow.moraleBar:IsTextVisible() );
	self.MoraleTextCheckBox:SetText( "Display Morale text?" );
	self.MoraleTextCheckBox:SetSize( self:GetWidth()-50, 40 );
	self.MoraleTextCheckBox:SetPosition( 20, self.StackedCheckBox:GetTop()+45 );

	self.MoralePercentCheckBox = Faflaf.FormElements.CheckBox();
	self.MoralePercentCheckBox:SetParent( self );
	self.MoralePercentCheckBox:SetChecked( vitalsWindow.moraleBar:GetShowPercentage() );
	self.MoralePercentCheckBox:SetText( "Display Morale as percentage?" );
	self.MoralePercentCheckBox:SetSize( self:GetWidth()-50, 40 );
	self.MoralePercentCheckBox:SetPosition( 20, self.MoraleTextCheckBox:GetTop()+45 );

	self.PowerTextCheckBox = Faflaf.FormElements.CheckBox();
	self.PowerTextCheckBox:SetParent( self );
	self.PowerTextCheckBox:SetChecked( vitalsWindow.powerBar:IsTextVisible() );
	self.PowerTextCheckBox:SetText( "Display Power text?" );
	self.PowerTextCheckBox:SetSize( self:GetWidth()-50, 40 );
	self.PowerTextCheckBox:SetPosition( 20, self.MoralePercentCheckBox:GetTop()+45 );

	self.PowerPercentCheckBox = Faflaf.FormElements.CheckBox();
	self.PowerPercentCheckBox:SetParent( self );
	self.PowerPercentCheckBox:SetChecked( vitalsWindow.powerBar:GetShowPercentage() );
	self.PowerPercentCheckBox:SetText( "Display Power as percentage?" );
	self.PowerPercentCheckBox:SetSize( self:GetWidth()-50, 40 );
	self.PowerPercentCheckBox:SetPosition( 20, self.PowerTextCheckBox:GetTop()+45 );

	self.LevelCheckBox = Faflaf.FormElements.CheckBox();
	self.LevelCheckBox:SetParent( self );
	self.LevelCheckBox:SetChecked( vitalsWindow.levelLabel:IsVisible() );
	self.LevelCheckBox:SetText( "Display level on Morale bar?" );
	self.LevelCheckBox:SetSize( self:GetWidth()-50, 40 );
	self.LevelCheckBox:SetPosition( 20, self.PowerPercentCheckBox:GetTop()+45 );
	
	self.NameCheckBox = Faflaf.FormElements.CheckBox();
	self.NameCheckBox:SetParent( self );
	self.NameCheckBox:SetChecked( vitalsWindow.nameLabel:IsVisible() );
	self.NameCheckBox:SetText( "Display Name on Morale bar?" );
	self.NameCheckBox:SetSize( self:GetWidth()-50, 40 );
	self.NameCheckBox:SetPosition( 20, self.LevelCheckBox:GetTop()+45 );

	-- setup buttons
	self.CancelButton = Turbine.UI.Lotro.Button();
	self.CancelButton:SetParent( self );
	self.CancelButton:SetText( "Cancel" );
	self.CancelButton:SetSize( 70, 20 );
	self.CancelButton:SetPosition( self:GetWidth()-90, self:GetHeight()-40 );
	self.CancelButton.Click = function( sender, args )
		self:Close();
	end

	self.ApplyButton = Turbine.UI.Lotro.Button();
	self.ApplyButton:SetParent( self );
	self.ApplyButton:SetText( "Apply" );
	self.ApplyButton:SetSize( 70, 20 );
	self.ApplyButton:SetPosition( self.CancelButton:GetLeft()-73, self:GetHeight()-40);
	self.ApplyButton.Click = function( sender, args )
		self:ApplyOptions();
	end

	self.OkButton = Turbine.UI.Lotro.Button();
	self.OkButton:SetParent( self );
	self.OkButton:SetText( "Ok" );
	self.OkButton:SetSize( 70, 20 );
	self.OkButton:SetPosition( self.ApplyButton:GetLeft()-73, self:GetHeight()-40 );
	self.OkButton.Click = function( sender, args )
		self:ApplyOptions();
		self:Close();
	end
end

function OptionsWindow:ApplyOptions()
	settings.MoraleWidth = self.MoraleSlider:GetValue();
	settings.PowerWidth = self.PowerSlider:GetValue();
	settings.UseMoralePercentage = self.MoralePercentCheckBox:IsChecked();
	settings.UsePowerPercentage = self.PowerPercentCheckBox:IsChecked();
	settings.IsMoraleTextVisible = self.MoraleTextCheckBox:IsChecked();
	settings.IsPowerTextVisible = self.PowerTextCheckBox:IsChecked();
	settings.IsNameVisible = self.NameCheckBox:IsChecked();
	settings.IsLevelVisible = self.LevelCheckBox:IsChecked();
	settings.IsStacked = self.StackedCheckBox:IsChecked();
	settings.ShowDefault = self.HideCheckBox:IsChecked();
	settings:Save();

	vitalsWindow:PerformLayout()

	Turbine.UI.Lotro.LotroUI.SetEnabled( Turbine.UI.Lotro.LotroUIElement.Vitals, settings.ShowDefault );
end