Settings = class();

function Settings:Constructor()
	self:Load();
end

function Settings:Load()
	local saved = Turbine.PluginData.Load( Turbine.DataScope.Character, "vitalbars" );
	if (type(saved) ~= "table") then
        -- set some reasonable defaults
        self:SetDefaults();
        self:Save()
    else
        for n,v in pairs(saved) do
            self[n] = v;
        end
    end
end

function Settings:SetDefaults()
	self.WindowLeft = 10;
	self.WindowTop = 10;
	self.MoraleWidth = 320;
	self.PowerWidth = 320;
	self.UseMoralePercentage = false;
	self.UsePowerPercentage = false;
	self.IsMoraleTextVisible = true;
	self.IsPowerTextVisible = true;
	self.IsNameVisible = true;
	self.IsLevelVisible = true;
	self.IsStacked = false;
	self.ShowDefault = false;
end

function Settings:Save()
	Turbine.PluginData.Save( Turbine.DataScope.Character, "vitalbars", self );
end